
package org.apache.beehive.controls.system.jms;

import java.beans.*;

import java.lang.reflect.Method;
import java.lang.reflect.UndeclaredThrowableException;
import java.util.HashMap;
import java.util.Map;

import org.apache.beehive.controls.api.bean.*;
import org.apache.beehive.controls.api.context.ControlBeanContext;
import org.apache.beehive.controls.api.properties.PropertyKey;
import org.apache.beehive.controls.api.properties.PropertyMap;
import org.apache.beehive.controls.api.versioning.*;

@SuppressWarnings("all")
public class JMSControlBean
extends org.apache.beehive.controls.runtime.bean.ControlBean
implements org.apache.beehive.controls.system.jms.JMSControl
{
    static final Method _setHeadersMethod;
    static final Method _setHeaderMethod;
    static final Method _getDestinationMethod;
    static final Method _getConnectionMethod;
    static final Method _setPropertiesMethod;
    static final Method _getSessionMethod;
    static final Method _setPropertyMethod;
    
    //
    // This HashMap will map from a Method to the array of names for parameters of the
    // method.  This is necessary because parameter name data isn't carried along in the
    // class file, but if available can enable ease of use by referencing parameters by
    // the declared name (vs. by index).
    //
    // This map should be read-only after its initialization in the static block, hence
    // using a plain HashMap is thread-safe.
    //
    static HashMap<Method, String []> _methodParamMap = new HashMap<Method, String []>();
    
    static
    {
        
        
        try
        {
            _setHeadersMethod = org.apache.beehive.controls.system.jms.JMSControl.class.getMethod("setHeaders", new Class [] {java.util.Map.class});
            _methodParamMap.put(_setHeadersMethod, new String [] { "headers" });
            _setHeaderMethod = org.apache.beehive.controls.system.jms.JMSControl.class.getMethod("setHeader", new Class [] {org.apache.beehive.controls.system.jms.JMSControl.HeaderType.class, java.lang.Object.class});
            _methodParamMap.put(_setHeaderMethod, new String [] { "type", "value" });
            _getDestinationMethod = org.apache.beehive.controls.system.jms.JMSControl.class.getMethod("getDestination", new Class [] {});
            _methodParamMap.put(_getDestinationMethod, new String [] {  });
            _getConnectionMethod = org.apache.beehive.controls.system.jms.JMSControl.class.getMethod("getConnection", new Class [] {});
            _methodParamMap.put(_getConnectionMethod, new String [] {  });
            _setPropertiesMethod = org.apache.beehive.controls.system.jms.JMSControl.class.getMethod("setProperties", new Class [] {java.util.Map.class});
            _methodParamMap.put(_setPropertiesMethod, new String [] { "properties" });
            _getSessionMethod = org.apache.beehive.controls.system.jms.JMSControl.class.getMethod("getSession", new Class [] {});
            _methodParamMap.put(_getSessionMethod, new String [] {  });
            _setPropertyMethod = org.apache.beehive.controls.system.jms.JMSControl.class.getMethod("setProperty", new Class [] {java.lang.String.class, java.lang.Object.class});
            _methodParamMap.put(_setPropertyMethod, new String [] { "name", "value" });
        }
        catch (NoSuchMethodException __bc_nsme)
        {
            throw new ExceptionInInitializerError(__bc_nsme);
        }
    }
    
    
    
    static
    {
        
    }
    
    
    
    /**
    * This is the public constructor for the class.  A client-defined control ID may
    * be provided.  This ID must be unique within the nesting ControlBeanContext.
    * @param context The containing ControlBeanContext
    * @param id The control identifier (or null to autogenerate a unique value)
    * @param props The initialization Properties for the new instance (or null for defaults)
    */
    public JMSControlBean(ControlBeanContext context, String id, PropertyMap props)
    {
        this(context, id, props, org.apache.beehive.controls.system.jms.JMSControl.class);
    }
    
    /**
    * This is the public null-arg constructor for this ControlBean.  If a control id
    * is not provided, a unique value will be auto-generated.
    */
    public JMSControlBean()
    {
        this(null, null, null);
    }
    
    /**
    * This is the protected version that is used by any ControlBean subclass
    */
    protected JMSControlBean(ControlBeanContext context, String id, PropertyMap props, Class controlClass)
    {
        super(context, id, props, controlClass);
        
    }
    
    
    /**
    * Returns an array of parameter names for the request method, or null if no parameter
    * data is available.
    */
    protected String [] getParameterNames(Method m)
    {
        // Check the local map for operations on this bean type
        if (_methodParamMap.containsKey(m))
        {
            return _methodParamMap.get(m);
        }
        
        // Delegate up if not found locally
        return super.getParameterNames(m);
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jms.JMSControl.setHeaders
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  void setHeaders(java.util.Map headers) 
    {
        Object [] __bc_argArray = new Object[] { headers };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jms.JMSControl __bc_target = (org.apache.beehive.controls.system.jms.JMSControl)ensureControl();
        
        try
        {
            preInvoke(_setHeadersMethod, __bc_argArray);
            
            __bc_target.setHeaders(headers)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = null;
            postInvoke(_setHeadersMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jms.JMSControl.setHeader
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  void setHeader(org.apache.beehive.controls.system.jms.JMSControl.HeaderType type, java.lang.Object value) 
    {
        Object [] __bc_argArray = new Object[] { type, value };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jms.JMSControl __bc_target = (org.apache.beehive.controls.system.jms.JMSControl)ensureControl();
        
        try
        {
            preInvoke(_setHeaderMethod, __bc_argArray);
            
            __bc_target.setHeader(type, value)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = null;
            postInvoke(_setHeaderMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jms.JMSControl.getDestination
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  javax.jms.Destination getDestination() throws org.apache.beehive.controls.api.ControlException
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jms.JMSControl __bc_target = (org.apache.beehive.controls.system.jms.JMSControl)ensureControl();
        javax.jms.Destination __bc_retval = null;
        
        try
        {
            preInvoke(_getDestinationMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getDestination()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            else if (__bc_t instanceof org.apache.beehive.controls.api.ControlException) throw (org.apache.beehive.controls.api.ControlException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getDestinationMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jms.JMSControl.getConnection
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  javax.jms.Connection getConnection() throws org.apache.beehive.controls.api.ControlException
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jms.JMSControl __bc_target = (org.apache.beehive.controls.system.jms.JMSControl)ensureControl();
        javax.jms.Connection __bc_retval = null;
        
        try
        {
            preInvoke(_getConnectionMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getConnection()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            else if (__bc_t instanceof org.apache.beehive.controls.api.ControlException) throw (org.apache.beehive.controls.api.ControlException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getConnectionMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jms.JMSControl.setProperties
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  void setProperties(java.util.Map properties) 
    {
        Object [] __bc_argArray = new Object[] { properties };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jms.JMSControl __bc_target = (org.apache.beehive.controls.system.jms.JMSControl)ensureControl();
        
        try
        {
            preInvoke(_setPropertiesMethod, __bc_argArray);
            
            __bc_target.setProperties(properties)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = null;
            postInvoke(_setPropertiesMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jms.JMSControl.getSession
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  javax.jms.Session getSession() throws org.apache.beehive.controls.api.ControlException
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jms.JMSControl __bc_target = (org.apache.beehive.controls.system.jms.JMSControl)ensureControl();
        javax.jms.Session __bc_retval = null;
        
        try
        {
            preInvoke(_getSessionMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getSession()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            else if (__bc_t instanceof org.apache.beehive.controls.api.ControlException) throw (org.apache.beehive.controls.api.ControlException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getSessionMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jms.JMSControl.setProperty
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  void setProperty(java.lang.String name, java.lang.Object value) 
    {
        Object [] __bc_argArray = new Object[] { name, value };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jms.JMSControl __bc_target = (org.apache.beehive.controls.system.jms.JMSControl)ensureControl();
        
        try
        {
            preInvoke(_setPropertyMethod, __bc_argArray);
            
            __bc_target.setProperty(name, value)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = null;
            postInvoke(_setPropertyMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
    }
    
    
    /**
    * A PropertyKey that can be used to access the controlImplementation property of the
    * BaseProperties PropertySet
    */
    public static final PropertyKey ControlImplementationKey = new PropertyKey(org.apache.beehive.controls.api.properties.BaseProperties.class, "controlImplementation");
    
    public synchronized void setControlImplementation(java.lang.String value)
    {
        
        setControlProperty(ControlImplementationKey, value);
    }
    
    public java.lang.String getControlImplementation()
    {
        return (java.lang.String)getControlProperty(ControlImplementationKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * Message PropertySet
    */
    public static final PropertyKey MessageValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Message.class, "value");
    
    public synchronized void setMessageValue(org.apache.beehive.controls.system.jms.JMSControl.MessageType value)
    {
        
        setControlProperty(MessageValueKey, value);
    }
    
    public org.apache.beehive.controls.system.jms.JMSControl.MessageType getMessageValue()
    {
        return (org.apache.beehive.controls.system.jms.JMSControl.MessageType)getControlProperty(MessageValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the name property of the
    * PropertyValue PropertySet
    */
    public static final PropertyKey PropertyNameKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.PropertyValue.class, "name");
    
    public synchronized void setPropertyName(java.lang.String value)
    {
        
        setControlProperty(PropertyNameKey, value);
    }
    
    public java.lang.String getPropertyName()
    {
        return (java.lang.String)getControlProperty(PropertyNameKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * PropertyValue PropertySet
    */
    public static final PropertyKey PropertyValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.PropertyValue.class, "value");
    
    public synchronized void setPropertyValue(java.lang.String value)
    {
        
        setControlProperty(PropertyValueKey, value);
    }
    
    public java.lang.String getPropertyValue()
    {
        return (java.lang.String)getControlProperty(PropertyValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the type property of the
    * PropertyValue PropertySet
    */
    public static final PropertyKey PropertyTypeKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.PropertyValue.class, "type");
    
    public synchronized void setPropertyType(java.lang.Class value)
    {
        
        setControlProperty(PropertyTypeKey, value);
    }
    
    public java.lang.Class getPropertyType()
    {
        return (java.lang.Class)getControlProperty(PropertyTypeKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * Priority PropertySet
    */
    public static final PropertyKey PriorityValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Priority.class, "value");
    
    public synchronized void setPriorityValue(int value)
    {
        
        setControlProperty(PriorityValueKey, value);
    }
    
    public int getPriorityValue()
    {
        return (Integer)getControlProperty(PriorityValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * Type PropertySet
    */
    public static final PropertyKey TypeValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Type.class, "value");
    
    public synchronized void setTypeValue(java.lang.String value)
    {
        
        setControlProperty(TypeValueKey, value);
    }
    
    public java.lang.String getTypeValue()
    {
        return (java.lang.String)getControlProperty(TypeValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * CorrelationId PropertySet
    */
    public static final PropertyKey CorrelationIdValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.CorrelationId.class, "value");
    
    public synchronized void setCorrelationIdValue(java.lang.String value)
    {
        
        setControlProperty(CorrelationIdValueKey, value);
    }
    
    public java.lang.String getCorrelationIdValue()
    {
        return (java.lang.String)getControlProperty(CorrelationIdValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * Expiration PropertySet
    */
    public static final PropertyKey ExpirationValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Expiration.class, "value");
    
    public synchronized void setExpirationValue(long value)
    {
        
        setControlProperty(ExpirationValueKey, value);
    }
    
    public long getExpirationValue()
    {
        return (Long)getControlProperty(ExpirationValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * Delivery PropertySet
    */
    public static final PropertyKey DeliveryValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Delivery.class, "value");
    
    public synchronized void setDeliveryValue(org.apache.beehive.controls.system.jms.JMSControl.DeliveryMode value)
    {
        
        setControlProperty(DeliveryValueKey, value);
    }
    
    public org.apache.beehive.controls.system.jms.JMSControl.DeliveryMode getDeliveryValue()
    {
        return (org.apache.beehive.controls.system.jms.JMSControl.DeliveryMode)getControlProperty(DeliveryValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the value property of the
    * Properties PropertySet
    */
    public static final PropertyKey PropertiesValueKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Properties.class, "value");
    
    public synchronized void setPropertiesValue(org.apache.beehive.controls.system.jms.JMSControl.PropertyValue[] value)
    {
        
        setControlProperty(PropertiesValueKey, value);
    }
    
    public org.apache.beehive.controls.system.jms.JMSControl.PropertyValue[] getPropertiesValue()
    {
        return (org.apache.beehive.controls.system.jms.JMSControl.PropertyValue[])getControlProperty(PropertiesValueKey);
    }
    
    /**
    * A PropertyKey that can be used to access the sendJndiName property of the
    * Destination PropertySet
    */
    public static final PropertyKey SendJndiNameKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "sendJndiName");
    
    public synchronized void setSendJndiName(java.lang.String value)
    {
        
        setControlProperty(SendJndiNameKey, value);
    }
    
    public java.lang.String getSendJndiName()
    {
        return (java.lang.String)getControlProperty(SendJndiNameKey);
    }
    
    /**
    * A PropertyKey that can be used to access the sendCorrelationProperty property of the
    * Destination PropertySet
    */
    public static final PropertyKey SendCorrelationPropertyKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "sendCorrelationProperty");
    
    public synchronized void setSendCorrelationProperty(java.lang.String value)
    {
        
        setControlProperty(SendCorrelationPropertyKey, value);
    }
    
    public java.lang.String getSendCorrelationProperty()
    {
        return (java.lang.String)getControlProperty(SendCorrelationPropertyKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiConnectionFactory property of the
    * Destination PropertySet
    */
    public static final PropertyKey JndiConnectionFactoryKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "jndiConnectionFactory");
    
    public synchronized void setJndiConnectionFactory(java.lang.String value)
    {
        
        setControlProperty(JndiConnectionFactoryKey, value);
    }
    
    public java.lang.String getJndiConnectionFactory()
    {
        return (java.lang.String)getControlProperty(JndiConnectionFactoryKey);
    }
    
    /**
    * A PropertyKey that can be used to access the sendType property of the
    * Destination PropertySet
    */
    public static final PropertyKey SendTypeKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "sendType");
    
    public synchronized void setSendType(org.apache.beehive.controls.system.jms.JMSControl.DestinationType value)
    {
        
        setControlProperty(SendTypeKey, value);
    }
    
    public org.apache.beehive.controls.system.jms.JMSControl.DestinationType getSendType()
    {
        return (org.apache.beehive.controls.system.jms.JMSControl.DestinationType)getControlProperty(SendTypeKey);
    }
    
    /**
    * A PropertyKey that can be used to access the transacted property of the
    * Destination PropertySet
    */
    public static final PropertyKey TransactedKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "transacted");
    
    public synchronized void setTransacted(boolean value)
    {
        
        setControlProperty(TransactedKey, value);
    }
    
    public boolean isTransacted()
    {
        return (Boolean)getControlProperty(TransactedKey);
    }
    
    /**
    * A PropertyKey that can be used to access the acknowledgeMode property of the
    * Destination PropertySet
    */
    public static final PropertyKey AcknowledgeModeKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "acknowledgeMode");
    
    public synchronized void setAcknowledgeMode(org.apache.beehive.controls.system.jms.JMSControl.AcknowledgeMode value)
    {
        
        setControlProperty(AcknowledgeModeKey, value);
    }
    
    public org.apache.beehive.controls.system.jms.JMSControl.AcknowledgeMode getAcknowledgeMode()
    {
        return (org.apache.beehive.controls.system.jms.JMSControl.AcknowledgeMode)getControlProperty(AcknowledgeModeKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiContextFactory property of the
    * Destination PropertySet
    */
    public static final PropertyKey JndiContextFactoryKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "jndiContextFactory");
    
    public synchronized void setJndiContextFactory(java.lang.String value)
    {
        
        setControlProperty(JndiContextFactoryKey, value);
    }
    
    public java.lang.String getJndiContextFactory()
    {
        return (java.lang.String)getControlProperty(JndiContextFactoryKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiProviderURL property of the
    * Destination PropertySet
    */
    public static final PropertyKey JndiProviderURLKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "jndiProviderURL");
    
    public synchronized void setJndiProviderURL(java.lang.String value)
    {
        
        setControlProperty(JndiProviderURLKey, value);
    }
    
    public java.lang.String getJndiProviderURL()
    {
        return (java.lang.String)getControlProperty(JndiProviderURLKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiUsername property of the
    * Destination PropertySet
    */
    public static final PropertyKey JndiUsernameKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "jndiUsername");
    
    public synchronized void setJndiUsername(java.lang.String value)
    {
        
        setControlProperty(JndiUsernameKey, value);
    }
    
    public java.lang.String getJndiUsername()
    {
        return (java.lang.String)getControlProperty(JndiUsernameKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiPassword property of the
    * Destination PropertySet
    */
    public static final PropertyKey JndiPasswordKey = new PropertyKey(org.apache.beehive.controls.system.jms.JMSControl.Destination.class, "jndiPassword");
    
    public synchronized void setJndiPassword(java.lang.String value)
    {
        
        setControlProperty(JndiPasswordKey, value);
    }
    
    public java.lang.String getJndiPassword()
    {
        return (java.lang.String)getControlProperty(JndiPasswordKey);
    }
    
    
    
    
    
    /**
    * The _annotCache maintains a lookup cache from AnnotatedElements to an associated
    * PropertyMap.  This enables these maps to be shared across multiple beans.
    */
    static private HashMap __bc_annotCache = new HashMap();
    
    protected Map getPropertyMapCache() { return __bc_annotCache; }
    
    private static final long serialVersionUID = 1L;
}
