
package org.apache.beehive.controls.system.jndi;

import java.beans.*;

import java.lang.reflect.Method;
import java.lang.reflect.UndeclaredThrowableException;
import java.util.HashMap;
import java.util.Map;

import org.apache.beehive.controls.api.bean.*;
import org.apache.beehive.controls.api.context.ControlBeanContext;
import org.apache.beehive.controls.api.properties.PropertyKey;
import org.apache.beehive.controls.api.properties.PropertyMap;
import org.apache.beehive.controls.api.versioning.*;

@SuppressWarnings("all")
public class JndiControlBean
extends org.apache.beehive.controls.runtime.bean.ControlBean
implements org.apache.beehive.controls.system.jndi.JndiControl
{
    static final Method _getResourceMethod;
    static final Method _getInitialContextMethod;
    
    //
    // This HashMap will map from a Method to the array of names for parameters of the
    // method.  This is necessary because parameter name data isn't carried along in the
    // class file, but if available can enable ease of use by referencing parameters by
    // the declared name (vs. by index).
    //
    // This map should be read-only after its initialization in the static block, hence
    // using a plain HashMap is thread-safe.
    //
    static HashMap<Method, String []> _methodParamMap = new HashMap<Method, String []>();
    
    static
    {
        
        
        try
        {
            _getResourceMethod = org.apache.beehive.controls.system.jndi.JndiControl.class.getMethod("getResource", new Class [] {java.lang.String.class, java.lang.Class.class});
            _methodParamMap.put(_getResourceMethod, new String [] { "resource", "resourceClass" });
            _getInitialContextMethod = org.apache.beehive.controls.system.jndi.JndiControl.class.getMethod("getInitialContext", new Class [] {});
            _methodParamMap.put(_getInitialContextMethod, new String [] {  });
        }
        catch (NoSuchMethodException __bc_nsme)
        {
            throw new ExceptionInInitializerError(__bc_nsme);
        }
    }
    
    
    
    static
    {
        
    }
    
    
    
    /**
    * This is the public constructor for the class.  A client-defined control ID may
    * be provided.  This ID must be unique within the nesting ControlBeanContext.
    * @param context The containing ControlBeanContext
    * @param id The control identifier (or null to autogenerate a unique value)
    * @param props The initialization Properties for the new instance (or null for defaults)
    */
    public JndiControlBean(ControlBeanContext context, String id, PropertyMap props)
    {
        this(context, id, props, org.apache.beehive.controls.system.jndi.JndiControl.class);
    }
    
    /**
    * This is the public null-arg constructor for this ControlBean.  If a control id
    * is not provided, a unique value will be auto-generated.
    */
    public JndiControlBean()
    {
        this(null, null, null);
    }
    
    /**
    * This is the protected version that is used by any ControlBean subclass
    */
    protected JndiControlBean(ControlBeanContext context, String id, PropertyMap props, Class controlClass)
    {
        super(context, id, props, controlClass);
        
    }
    
    
    /**
    * Returns an array of parameter names for the request method, or null if no parameter
    * data is available.
    */
    protected String [] getParameterNames(Method m)
    {
        // Check the local map for operations on this bean type
        if (_methodParamMap.containsKey(m))
        {
            return _methodParamMap.get(m);
        }
        
        // Delegate up if not found locally
        return super.getParameterNames(m);
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jndi.JndiControl.getResource
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  java.lang.Object getResource(java.lang.String resource, java.lang.Class resourceClass) throws org.apache.beehive.controls.api.ControlException
    {
        Object [] __bc_argArray = new Object[] { resource, resourceClass };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jndi.JndiControl __bc_target = (org.apache.beehive.controls.system.jndi.JndiControl)ensureControl();
        java.lang.Object __bc_retval = null;
        
        try
        {
            preInvoke(_getResourceMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getResource(resource, resourceClass)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            else if (__bc_t instanceof org.apache.beehive.controls.api.ControlException) throw (org.apache.beehive.controls.api.ControlException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getResourceMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jndi.JndiControl.getInitialContext
    */
    @SuppressWarnings({"unchecked"}) // for __bc_retval cast
    public  javax.naming.InitialContext getInitialContext() throws org.apache.beehive.controls.api.ControlException
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jndi.JndiControl __bc_target = (org.apache.beehive.controls.system.jndi.JndiControl)ensureControl();
        javax.naming.InitialContext __bc_retval = null;
        
        try
        {
            preInvoke(_getInitialContextMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getInitialContext()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            else if (__bc_t instanceof org.apache.beehive.controls.api.ControlException) throw (org.apache.beehive.controls.api.ControlException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getInitialContextMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    
    /**
    * A PropertyKey that can be used to access the controlImplementation property of the
    * BaseProperties PropertySet
    */
    public static final PropertyKey ControlImplementationKey = new PropertyKey(org.apache.beehive.controls.api.properties.BaseProperties.class, "controlImplementation");
    
    public synchronized void setControlImplementation(java.lang.String value)
    {
        
        setControlProperty(ControlImplementationKey, value);
    }
    
    public java.lang.String getControlImplementation()
    {
        return (java.lang.String)getControlProperty(ControlImplementationKey);
    }
    
    /**
    * A PropertyKey that can be used to access the factory property of the
    * Properties PropertySet
    */
    public static final PropertyKey FactoryKey = new PropertyKey(org.apache.beehive.controls.system.jndi.JndiControl.Properties.class, "factory");
    
    public synchronized void setFactory(java.lang.String value)
    {
        
        setControlProperty(FactoryKey, value);
    }
    
    public java.lang.String getFactory()
    {
        return (java.lang.String)getControlProperty(FactoryKey);
    }
    
    /**
    * A PropertyKey that can be used to access the url property of the
    * Properties PropertySet
    */
    public static final PropertyKey UrlKey = new PropertyKey(org.apache.beehive.controls.system.jndi.JndiControl.Properties.class, "url");
    
    public synchronized void setUrl(java.lang.String value)
    {
        
        setControlProperty(UrlKey, value);
    }
    
    public java.lang.String getUrl()
    {
        return (java.lang.String)getControlProperty(UrlKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiSecurityPrincipal property of the
    * Properties PropertySet
    */
    public static final PropertyKey JndiSecurityPrincipalKey = new PropertyKey(org.apache.beehive.controls.system.jndi.JndiControl.Properties.class, "jndiSecurityPrincipal");
    
    public synchronized void setJndiSecurityPrincipal(java.lang.String value)
    {
        
        setControlProperty(JndiSecurityPrincipalKey, value);
    }
    
    public java.lang.String getJndiSecurityPrincipal()
    {
        return (java.lang.String)getControlProperty(JndiSecurityPrincipalKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiSecurityCredentials property of the
    * Properties PropertySet
    */
    public static final PropertyKey JndiSecurityCredentialsKey = new PropertyKey(org.apache.beehive.controls.system.jndi.JndiControl.Properties.class, "jndiSecurityCredentials");
    
    public synchronized void setJndiSecurityCredentials(java.lang.String value)
    {
        
        setControlProperty(JndiSecurityCredentialsKey, value);
    }
    
    public java.lang.String getJndiSecurityCredentials()
    {
        return (java.lang.String)getControlProperty(JndiSecurityCredentialsKey);
    }
    
    
    
    
    
    /**
    * The _annotCache maintains a lookup cache from AnnotatedElements to an associated
    * PropertyMap.  This enables these maps to be shared across multiple beans.
    */
    static private HashMap __bc_annotCache = new HashMap();
    
    protected Map getPropertyMapCache() { return __bc_annotCache; }
    
    private static final long serialVersionUID = 1L;
}
