package org.apache.beehive.controls.system.jndi;

import java.beans.BeanDescriptor;
import java.beans.EventSetDescriptor;
import java.beans.IntrospectionException;
import java.beans.MethodDescriptor;
import java.beans.ParameterDescriptor;
import java.beans.PropertyDescriptor;
import java.beans.PropertyEditor;
import java.lang.reflect.Method;
import java.util.HashMap;

import org.apache.beehive.controls.api.ControlException;
import org.apache.beehive.controls.runtime.bean.BeanPersistenceDelegate;
import org.apache.beehive.controls.runtime.packaging.ControlEventSetDescriptor;

@SuppressWarnings("all")
public class JndiControlBeanBeanInfo
extends org.apache.beehive.controls.runtime.bean.ControlBeanInfo
{
    static final Method _getResourceMethod;
    static final Method _getInitialContextMethod;
    
    //
    // This HashMap will map from a Method to the array of names for parameters of the
    // method.  This is necessary because parameter name data isn't carried along in the
    // class file, but if available can enable ease of use by referencing parameters by
    // the declared name (vs. by index).
    //
    // This map should be read-only after its initialization in the static block, hence
    // using a plain HashMap is thread-safe.
    //
    static HashMap<Method, String []> _methodParamMap = new HashMap<Method, String []>();
    
    static
    {
        
        
        try
        {
            _getResourceMethod = org.apache.beehive.controls.system.jndi.JndiControl.class.getMethod("getResource", new Class [] {java.lang.String.class, java.lang.Class.class});
            _methodParamMap.put(_getResourceMethod, new String [] { "resource", "resourceClass" });
            _getInitialContextMethod = org.apache.beehive.controls.system.jndi.JndiControl.class.getMethod("getInitialContext", new Class [] {});
            _methodParamMap.put(_getInitialContextMethod, new String [] {  });
        }
        catch (NoSuchMethodException __bc_nsme)
        {
            throw new ExceptionInInitializerError(__bc_nsme);
        }
    }
    
    /**
    * Default null-arg constructor used to create a new BeanInfo instance
    */
    public JndiControlBeanBeanInfo()
    {
        super(org.apache.beehive.controls.system.jndi.JndiControlBean.class);
    }
    
    /**
    * Protected constructor used if this BeanInfo class is extended.
    */
    protected JndiControlBeanBeanInfo(Class beanClass)
    {
        super(beanClass);
    }
    
    // java.beans.BeanInfo.getBeanDescriptor
    public BeanDescriptor getBeanDescriptor()
    {
        BeanDescriptor bd = new BeanDescriptor(org.apache.beehive.controls.system.jndi.JndiControlBean.class);
        bd.setName( "JndiControlBean" );
        bd.setDisplayName( "JndiControlBean" );
        
        //
        // The org.apache.beehive.controls.runtime.bean.BeanPersistenceDelegate class
        // implements the XMLDecode delegation model for all Control JavaBean types. It
        // provides optimized XML persistance based upon the Control runtime architecture.
        // The 'persistenceDelegate' attribute of a BeanDescriptor is used by XMLEncoder to
        // locate a delegate for a particular JavaBean type.
        //
        bd.setValue("persistenceDelegate", new BeanPersistenceDelegate());
        
        return bd;
    }
    
    /**
    * Stores MethodDescriptor descriptors for this bean and its superclasses into
    * an array, starting at the specified index
    */
    protected void initMethodDescriptors(MethodDescriptor [] methodDescriptors, int index)
    throws java.beans.IntrospectionException
    {
        String [] __bc_paramNames;
        ParameterDescriptor [] __bc_paramDescriptors;
        MethodDescriptor md;
        
        //
        // Declare MethodDescriptor for getResource(resource, resourceClass)
        //
        __bc_paramNames = _methodParamMap.get(_getResourceMethod);
        __bc_paramDescriptors = new ParameterDescriptor[__bc_paramNames.length];
        for (int j = 0; j < __bc_paramNames.length; j++)
        {
            __bc_paramDescriptors[j] = new ParameterDescriptor();
            __bc_paramDescriptors[j].setName(__bc_paramNames[j]);
            __bc_paramDescriptors[j].setDisplayName(__bc_paramNames[j]);
        }
        md = new MethodDescriptor(_getResourceMethod, __bc_paramDescriptors);
        methodDescriptors[index++] = md;
        
        //
        // Declare MethodDescriptor for getInitialContext()
        //
        __bc_paramNames = _methodParamMap.get(_getInitialContextMethod);
        __bc_paramDescriptors = new ParameterDescriptor[__bc_paramNames.length];
        for (int j = 0; j < __bc_paramNames.length; j++)
        {
            __bc_paramDescriptors[j] = new ParameterDescriptor();
            __bc_paramDescriptors[j].setName(__bc_paramNames[j]);
            __bc_paramDescriptors[j].setDisplayName(__bc_paramNames[j]);
        }
        md = new MethodDescriptor(_getInitialContextMethod, __bc_paramDescriptors);
        methodDescriptors[index++] = md;
        
        
    }
    
    public MethodDescriptor [] getMethodDescriptors()
    {
        MethodDescriptor [] __bc_methodDescriptors = new MethodDescriptor[2];
        try
        {
            initMethodDescriptors(__bc_methodDescriptors, 0);
        }
        catch (java.beans.IntrospectionException __bc_ie)
        {
            throw new ControlException("Unable to create MethodDescriptor", __bc_ie);
        }
        return __bc_methodDescriptors;
    }
    
    /**
    * Stores PropertyDescriptor descriptors for this bean and its superclasses into
    * an array, starting at the specified index
    */
    protected void initPropertyDescriptors(PropertyDescriptor [] propDescriptors, int index)
    throws java.beans.IntrospectionException
    {
        PropertyDescriptor pd;
        
        pd = new PropertyDescriptor( "controlImplementation" , org.apache.beehive.controls.system.jndi.JndiControlBean.class, "getControlImplementation", "setControlImplementation");
        propDescriptors[index++] = pd;
        pd = new PropertyDescriptor( "factory" , org.apache.beehive.controls.system.jndi.JndiControlBean.class, "getFactory", "setFactory");
        pd.setName("factory");
        pd.setDisplayName("factory");
        pd.setShortDescription( "JNDI context factory" );
        pd.setExpert(false);
        pd.setHidden(false);
        pd.setPreferred(false);
        propDescriptors[index++] = pd;
        pd = new PropertyDescriptor( "url" , org.apache.beehive.controls.system.jndi.JndiControlBean.class, "getUrl", "setUrl");
        pd.setName("url");
        pd.setDisplayName("url");
        pd.setShortDescription( "JNDI provider URL" );
        pd.setExpert(false);
        pd.setHidden(false);
        pd.setPreferred(false);
        propDescriptors[index++] = pd;
        pd = new PropertyDescriptor( "jndiSecurityPrincipal" , org.apache.beehive.controls.system.jndi.JndiControlBean.class, "getJndiSecurityPrincipal", "setJndiSecurityPrincipal");
        pd.setName("jndiSecurityPrincipal");
        pd.setDisplayName("jndiSecurityPrincipal");
        pd.setShortDescription( "JNDI security principal" );
        pd.setExpert(false);
        pd.setHidden(false);
        pd.setPreferred(false);
        propDescriptors[index++] = pd;
        pd = new PropertyDescriptor( "jndiSecurityCredentials" , org.apache.beehive.controls.system.jndi.JndiControlBean.class, "getJndiSecurityCredentials", "setJndiSecurityCredentials");
        pd.setName("jndiSecurityCredentials");
        pd.setDisplayName("jndiSecurityCredentials");
        pd.setShortDescription( "JNDI security credentials" );
        pd.setExpert(false);
        pd.setHidden(false);
        pd.setPreferred(false);
        propDescriptors[index++] = pd;
        
        //
        // add property descriptors for any getter/setters defined in control interface
        //
        pd = new PropertyDescriptor( "initialContext" , org.apache.beehive.controls.system.jndi.JndiControlBean.class, "getInitialContext", null);
        propDescriptors[index++] = pd;
        
    }
    
    // java.beans.BeanInfo.getPropertyDescriptors
    public PropertyDescriptor [] getPropertyDescriptors()
    {
        PropertyDescriptor [] __bc_propDescriptors = new PropertyDescriptor[6];
        try
        {
            initPropertyDescriptors(__bc_propDescriptors, 0);
        }
        catch (java.beans.IntrospectionException __bc_ie)
        {
            throw new ControlException("Unable to create PropertyDescriptor", __bc_ie);
        }
        return __bc_propDescriptors;
    }
    
    
    protected void initEventSetDescriptors(EventSetDescriptor [] eventSetDescriptors, int index)
    throws java.beans.IntrospectionException
    {
        
        
    }
    
    // java.beans.BeanInfo.getEventSetDescriptors
    public EventSetDescriptor [] getEventSetDescriptors()
    {
        EventSetDescriptor [] __bc_eventSetDescriptors = new EventSetDescriptor[0];
        try
        {
            initEventSetDescriptors(__bc_eventSetDescriptors, 0);
        }
        catch (java.beans.IntrospectionException __bc_ie)
        {
            throw new ControlException("Unable to create EventSetDescriptor", __bc_ie);
        }
        return __bc_eventSetDescriptors;
    }
}
